----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/10/2015 10:59:49 AM
-- Design Name: 
-- Module Name: VGAram - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity VGAram is
Port ( clk : in STD_LOGIC;
       resetn : in STD_LOGIC;
       rgbin: in STD_LOGIC_VECTOR(5 downto 0);
       xyin: in STD_LOGIC_VECTOR(17 downto 0);
       enin: in STD_LOGIC;
           
       rgb: out STD_LOGIC_VECTOR(5 downto 0);
       xy: out STD_LOGIC_VECTOR(17 downto 0);       
       en: out STD_LOGIC;           
                      
       BRAM_en : out STD_LOGIC;           
       BRAM_dout : out STD_LOGIC_VECTOR (31 downto 0);
       BRAM_din : in STD_LOGIC_VECTOR (31 downto 0);
       BRAM_we : out STD_LOGIC_VECTOR (3 downto 0);          
       BRAM_addr : out STD_LOGIC_VECTOR (31 downto 0); 
       BRAM_clk : out STD_LOGIC;
       BRAM_rst : out STD_LOGIC
      );
end VGAram;

architecture Behavioral of VGAram is
 signal x,y: unsigned(8 downto 0);
 signal en1: std_logic;
 signal xy1: std_logic_vector(17 downto 0);
 signal rgb1: std_logic_vector(5 downto 0);
begin

BRAM_clk <= clk;
BRAM_rst <= not resetn;

-- konstantni kontrolni signali, BRAM le beremo
BRAM_en <= '1';
BRAM_dout <= (others => '0');
BRAM_we <= (others => '0');

-- pretvori koordinate v pozitivna stevila (0,0) v levem zgornjem vogalu
x <= unsigned(xyin(17 downto 9))+to_unsigned(256,9);
y <= unsigned(xyin(8 downto 0))+to_unsigned(256,9);
BRAM_addr <= "00000000000000" & std_logic_vector(y) & std_logic_vector(x);

p: Process(clk)
begin
 if rising_edge(clk) then   
   xy1 <= xyin;  -- zakasnitev vhodnih signalov za 1 cikel   
   en1 <= enin;
   rgb1 <= rgbin;
   
   en <= en1; -- izhodi
   xy <= xy1;      
   rgb <= rgb1;   
   if en1='1' then -- beri iz BRAM, e smo znotraj obmoja   
     case xy1(10 downto 9) is
        when "00" => rgb <= BRAM_din(5 downto 0);
        when "01" => rgb <= BRAM_din(13 downto 8);
        when "10" => rgb <= BRAM_din(21 downto 16);
        when others => rgb <= BRAM_din(29 downto 24);
     end case;     
   end if;
 end if;
end process;

end Behavioral;
